; =======================================
; Plot LOGO for MSX2+ with antialiasing
; to insert in MSXKANJI.ROM file.
; Binary result: KNMSXBOY.ROM
; Size of logo: 454*71 dots
; Hex Editor Address: $399d - $3fff
; Modified by KdL 2020.01.12
; Coded in TWZ'CA3 w/ TASM80 v3.2ud
; =======================================

    .org    07A00h - 99         ; StartProg - MainProg = 99 bytes               <---------------------
;   .org    0100h               ; MSX_BOY.COM

MainProg:
;   jp      startProg           ; 3 bytes -> required for MSX_BOY.COM
;\------------------------------
Line_EX_COM:                    ; 13 bytes
    push    de
    ld  e, 70h                  ; Line Execution Command
loc_7C2F:
    ld  d, 2Eh                  ; R#46 - Command Register
    call    wr_dat2reg
    call    wait_CE
    pop de
    ret
; ==============================
sub_7C3E:                       ; 67 bytes
    ld  a, 0Dh                  ; RTC#13 mode register
    out (0B4h), a
    in  a, (0B5h)
    and 0Ch
    or  2
    out (0B5h), a               ; Select Block 2
    ld  a, 0Bh                  ; Register Color/Title
    out (0B4h), a
    in  a, (0B5h)               ; (Color/Title) -> Code (Color)=0..3
    rlca
;   rlca
    and 06h                     ; 0Ch by default
    ld  c, a
    ld  b, 0
    ld  hl, tab_7CA4            ; Color table
    add hl, bc
    ld  c, (hl)
    inc hl
    ld  b, (hl)
    push    bc
;   inc hl
;   ld  e, (hl)
;   inc hl
;   ld  d, (hl)
;   ex  de, hl
; Set Palette Register address
    ld  de, 1000h               ; 00H -> R#16
    ld  h, e                    ; 0/0/0 -> black
    ld  l, e
    call    wr_dat2reg
; Set Palette Register 0...7
    call    sub_7C7A
    pop hl                      ; RED/BLUE/GREEN -> bg color
    call    sub_7C7A
    ld  hl, 0444h               ; 4/4/4 -> gray
    call    sub_7C7A
    ld  hl, 0777h               ; 7/7/7 -> white
; ------------------------------
sub_7C7A:
    push    bc
    ld  c, 9Ah
    out (c), l
    ex  (sp), hl
    ex  (sp), hl
    out (c), h
    pop bc
    ret
; ==============================
; hl=
sub_7A9F:                       ; 19 bytes
    dec hl
    ld  a, l
    srl h
    rra
    rrca
    rrca
    inc a
    and 3Fh
    ld  h, a
    inc l
    ld  a, l
    neg
    and 7
    ld  l, a
    ret
; ==============================
startProg:                      ; 3A00h of MSXKANJI.ROM, 7A00h of MSX memory    <---------------------
    di
    call    sub_7ADA            ; Init
    call    sub_7A09            ; View
    ei
    ret                         ; Exit
loop4DOS:
;   jr      loop4DOS            ; Loop test for MSX_BOY.COM
;   
; ==============================
; View LOGO
sub_7A09:
    ld  hl, 00FFh               ;
    call    sub_7A9F            ;
;
    ld  e, h
    ld  d, 1Ah                  ; R#26
    call    wr_dat2reg
    ld  e, l
    ld  d, 1Bh                  ; R#27
    call    wr_dat2reg
;
    call    sub_7A83            ; Wait 2 VR
;
    ld  de, 0163h
    call    wr_dat2reg          ; 63h -> R#1
    ld  hl, 00E1h
    ld  de, 0FFF6h
loc_7A2A:
    inc de                      ;
    ld  b, 5
loc_7A2D:
    push    bc
    push    de
    call    sub_7A48
    pop de
    pop bc
    add hl, de
    djnz    loc_7A2D
;\------------------------------
    ld  a, e
    or  a
    jr  nz, loc_7A2A
;\------------------------------
    ld  de, 1900h
    call    wr_dat2reg          ; 00h -> R#25
    ld  de, 21Fh
    call    wr_dat2reg          ; 1Fh -> R#2
    ret
; ==============================
sub_7A48:
    push    hl
    call    sub_7A83            ; Wait 2 VR
    xor a
    sub l
    ld  e, a
    ld  a, 2
    sbc a, h
    ld  d, a
    call    sub_7A9F
    ex  de, hl
    call    sub_7A9F
    ld  bc, 559Bh
loc_7A5D:
    ld  a, 1Ah                  ; Data 1Ah
    out (99h), a
    ld  a, 91h                  ; R#17 - Control register pointer
    out (99h), a
    ex  de, hl
    in  a, (99h)
loc_7A68:
    in  a, (99h)
    and 20h                     ; Bit 5 -
    jr  z, loc_7A68             ; +1 byte free (jp -> jr)
;\------------------------------
    out (c), h
    out (c), l
    djnz    loc_7A5D
;\------------------------------
    pop hl
    ld  de, 1A00h               ; 00h -> R#26
    call    wr_dat2reg
    ld  de, 1B00h               ; 00H -> R#27
    call    wr_dat2reg
    ret
; ==============================
; WAIT 2 Vertical scanning line
sub_7A83:
    ld  a, 2                    ; S#2
    out (99h), a                ; Data = 02H
    ld  a, 8Fh                  ; R#15 - Status register pointer
    out (99h), a
loc_7A8B:
    in  a, (99h)
    and 40h                     ; Bit 6 - Flag VR
    jr  z, loc_7A8B 
;\------------------------------
loc_7A91:
    in  a, (99h)
    and 40h                     ; Bit 6 - Flag VR
    jr  nz, loc_7A91
;\------------------------------
    xor a                       ; S#0
    out (99h), a
    ld  a, 8Fh                  ; R#15 - Status register pointer
    out (99h), a
    ret
; ==============================
; Init SCREEN memory and VDP registers
sub_7ADA:
    call    sub_7A83            ; Wait 2 VR
; Set Mode Register #1
; BL = 0 Screen disabled
; IE0 = 1 Enable IE0
; M1,M2 = 00
; SI = 1 Sprite Size 16x16
; MA = 1 Sprite expansion Enable
;   ld  de, 0123h               ; 23h -> R#1
;   call    wr_dat2reg          ; +6 bytes free
;
; ==============================
init_VDP:                       ; 15 bytes
    ld  b, 8
    ld  hl, tab_7C94            ; 08h -> R#0
loc_7C8A:
    ld  d, (hl)                 ; R#n
    inc hl
    ld  e, (hl)                 ; Data
    inc hl
    call    wr_dat2reg
    djnz    loc_7C8A

;
    ld  a, 55h                  ;
    ld  hl, 0
    ld  c, l
    ld  b, l
    call    wr_VRAM             ; Init VRAM
;
    call    sub_7C3E
; Set Text Color=0/Back drop color=5
    ld  de, 705h        ; 05H -> R#7
    call    wr_dat2reg
;
    ld  hl, 7800h               ; Sprite color table
    ld  bc, 30h
    ld  a, 0FFh                 ; pattern of right border => 0FFh by default
    call    wr_VRAM
    ld  hl, 7830h
    ld  bc, 10h
    ld  a, 000h                 ; pattern of left border => 0F0h by default     <---------------------
    call    wr_VRAM
    ld  hl, 7400h
    ld  a, 5
    ld  bc, 200h
    call    wr_VRAM
    ld  hl, tab_7AB2            ;
    ld  de, 7600h
    ld  bc, 28h
    call    sub_7BE5
;
    ld  de, 1903h               ; 03H -> R#25
    call    wr_dat2reg
    ld  de, 023Fh               ; 3FH -> R#2
    call    wr_dat2reg
;
    ld  de, 2D00h               ; 00H -> R#45
    call    wr_dat2reg
    ld  d, 2Ah                  ; 00H -> R#42
    call    wr_dat2reg
    inc d                       ; 00H -> R#43
    call    wr_dat2reg
    ld  d, 27h                  ; 00H -> R#39
    call    wr_dat2reg
    ld  e, 29h                  ; Y dest of logo image => 20h by default        <---------------------
    ld  hl, tab_7D3B            ; Table Logo Image
    exx
    ld  hl, tab_7CB4            ; Table Antialiasing bits
    exx
;\------------------------------
loc_7B50:
    ld  a, 3
    push    af
    ld  bc, 1Dh                 ; X dest of logo image => 2Dh by default        <---------------------
    ld  d, 26h                  ; R#38 - Y destination register
    call    wr_dat2reg
    exx
    ld  b, 8
    ld  c, (hl)                 ; tab_7CB4
    inc hl
    exx
;\------------------------------
loc_7B61:
    call    set_dest_X          ; R#36,37 - Dest X register
    ld  a, (hl)                 ; tab_7D3B
    inc hl
    cp  0FEh                    ; End line ?
    jr  z, loc_7BA1             ; Next Y
;
    push    hl
    push    bc
    ld  bc, 454                 ; Logo width => 422 by default                  <---------------------
    jr  nc, loc_7B74            ; a=0FFh Empty line
    ld  b, 0
    ld  c, a
loc_7B74:
    call    set_NDot_X          ; R#40,41 -> Number Dots X
    pop hl
    add hl, bc
    ld  c, l
    ld  b, h
    pop hl
    pop af
    xor 3
    call    set_Color
    push    af
    call    Line_EX_COM
    exx
    sla c
    djnz    loc_7B8F
    ld  b, 8
    ld  c, (hl)
    inc hl
loc_7B8F:
    exx
    jr  nc, loc_7B61
    dec bc
    call    set_dest_X          ; R#36,37 - Dest X register
    inc bc
    ld  a, 2                    ; BLUE
    call    set_Color
    call    PSET_EX_COM
    jr  loc_7B61
;\------------------------------
loc_7BA1:
    inc e                       ; Next Y
    pop af
    ld  a, (hl)
    cp  0FEh
    jr  nz, loc_7B50
    ret
; ==============================
wr_dat2reg:
    push    af
    ld  a, e                    ; Data
    out (99h), a
    ld  a, d                    ; Register
    or  80h
    out (99h), a
    pop af
    ret
; ==============================
wait_CE:
    ld  a, 2

; Read Status Register (A)
rd_Stat_A:
    out (99h), a
    ld  a, 8Fh                  ; R#15 - Status Register pointer
    out (99h), a
    push    hl
    pop hl
    in  a, (99h)                ; Read (Status Register)
    push    af
    xor a
    out (99h), a
    ld  a, 8Fh
    out (99h), a
    pop af
;
    rrca                        ; Bit 0 (CE) - Command Execution Flag
    jr  c, wait_CE
    rlca
    ret
; ==============================
; Write VRAM
; A - byte
; HL - address
; BC - LEN
wr_VRAM:
    push    af
    call    sub_7BFA            ; Set VRAM access adress
    ld  a, c
    or  a
    jr  z, loc_7BDB
    inc b
loc_7BDB:
    pop af
loc_7BDC:
    out (98h), a
    dec c
    jr  nz, loc_7BDC            ; +1 byte free (jp -> jr)
    djnz    loc_7BDC
;\------------------------------
    ret
; ==============================
sub_7BE5:
    ex  de, hl
    call    sub_7BFA
    ex  de, hl
    ld  a, c
    or  a
    ld  a, b
    ld  b, c
    ld  c, 98h                  ; Port Data VDP
    jr  z, loc_7BF3
    inc a
loc_7BF3:
    otir
    dec a
    jr  nz, loc_7BF3
    ex  de, hl
    ret
; ==============================
; Set VRAM Access base adress
sub_7BFA:
    ld  a, h
    and 3Fh
    or  40h
    ex  af, af'
    ld  a, h
    and 0C0h
    rlca
    rlca
    out (99h), a
    ld  a, 8Eh                  ; R#14 - VRAM Access Adress
    out (99h), a
    ld  a, l
    out (99h), a
    ex  af, af'
    out (99h), a
    ex  (sp), hl
    ex  (sp), hl
    ret
; ==============================
set_NDot_X:
    ld  d, 28h                  ; R#40,41 -> Number Dots X (28h by default)
    jr  loc_7C1A
; ==============================
set_dest_X:
    ld  d, 24h                  ; R#36,37 - Dest X register
loc_7C1A:
    push    de
    ld  e, c
    call    wr_dat2reg
    ld  e, b
    inc d
    jr  loc_7C27
; ==============================
set_Color:
    push    de
    ld  e, a
    ld  d, 2Ch                  ; R#44 - Color register
loc_7C27:
    call    wr_dat2reg
    pop de
    ret
; ==============================
PSET_EX_COM:
    push    de
    ld  e, 50h                  ; PSET Execution Command
    jp  loc_7C2F                ; R#46 - Command Register
; ==============================
; TAB init VDP registers
tab_7C94:
    .dw 0800h                   ; 08h -> R#0 Graphic 4 mode
    .dw 2301h                   ; 23h -> R#1
    .dw 2808h                   ; 28H -> R#8
    .dw 0009h                   ; 00h -> R#9
; Pattern name table base address = 7C00h
    .dw 1F02h                   ; 1FH -> R#2
; Sprite attribute table base address = 07780h
    .dw 0EF05h                  ; 0EFH -> R#5
    .dw 000Bh                   ; 00H -> R#11
; Sprite pattern generator table base address = 07800h
    .dw 0F06h                   ; 0FH -> R#6
; ==============================
; TAB PALETTE REGISTERS 0       ; 0..1 by default
tab_7CA4:
;   .dw 0007h                   ; Set Title ,1  (Blue - Black)
;   .dw 0000h
    .dw 0007h                   ; Blue bg
;
;   .dw 0420h                   ; Set Title ,2  (Green - Cyan)
;   .dw 0227h
    .dw 0510h                   ; Green bg
;
;   .dw 0272h                   ; Set Title ,3  (Red - Purple)
;   .dw 0056h
    .dw 0061h                   ; Red bg
;
;   .dw 0570h                   ; Set Title ,4  (Orange - Red)
;   .dw 0070h
    .dw 0470h                   ; Orange bg
; ==============================
; Sprite attribute
tab_7AB2:                       ; Y,X,pattern,0
    .db  1Ch, 0F0h, 0, 0        ; right mask position, X=0E8h by default        <---------------------
    .db  1Ch, 0F0h, 0, 0        ; right mask position                           <---------------------
    .db  3Ch, 0F0h, 0, 0        ; right mask position                           <---------------------
    .db  3Ch, 0F0h, 0, 0        ; right mask position                           <---------------------
    .db  5Ch, 0F0h, 0, 0        ; right mask position                           <---------------------
    .db  5Ch, 0F0h, 0, 0        ; right mask position                           <---------------------
    .db  1Ch,    0, 4, 0        ; left mask position, X=0 by default
    .db  3Ch,    0, 4, 0        ; left mask position
    .db  5Ch,    0, 4, 0        ; left mask position
    .db 0D8h                    ; .db 0D8h,    0, 0, 0 by default
; ==============================
; Table antialiasing bits
tab_7CB4:                       ; tab_7CB4 is accross to sprite attribute       <---------------------
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %01101111, %00000000
      .db %10011111, %00000000
      .db %01101111, %00000000
      .db %10011111, %00000000
      .db %01101111, %00000000
      .db %10011111, %00000000
      .db %01101111, %00000000
      .db %10010111, %00000000
      .db %01101111, %00000000
      .db %10011111, %00000000
      .db %01101111, %00000000
      .db %10011111, %00000000
      .db %01101111, %00000000
      .db %10010111, %00000000
      .db %01101100
      .db %10010111, %00000000
      .db %01100111, %00000000
      .db %10010111, %00000000
      .db %01100011, %00000000
      .db %10010111, %00000000
      .db %01100111, %00000000
      .db %10011111, %00000000
      .db %01100111, %00000000
      .db %10011111, %00000000
      .db %01101111, %01000000
      .db %10011111, %01000000
      .db %00111101, %00000000
      .db %11111100, %10000000
      .db %00011100, %00000000
      .db %11111100, %00110110, %00000000
      .db %00101100, %00111111, %00000000
      .db %11111100, %11111001, %00000000
      .db %00111101, %11110110, %00000000
      .db %10000111, %11011111, %11110000
      .db %01111011, %11010000, %10010000
      .db %10000111, %11010000, %01100000
      .db %01111010, %11001100, %00100100
      .db %10000111, %11000000, %00110000
      .db %01111010, %11000000, %00000000
      .db %10000110, %11000000, %00110000
      .db %01111000, %11000011, %11110000
      .db %10000110, %11001111, %11000000
      .db %01111010, %11110111, %11000000
      .db %10000110, %11110111, %01000000
      .db %01111111, %11011110, %00000000
      .db %10000011, %11000000
      .db %01111111, %11010000
      .db %10000111, %11010000
      .db %01111111, %11000000
      .db %10000111, %11000000
      .db %01111111, %11000000
      .db %10000011, %11000000
      .db %01111111, %11000000
      .db %10000111, %11000000
      .db %01111111, %11000000
      .db %10000111, %11000000
      .db %01111111, %11000000
      .db %10000111, %11000000
      .db %01111111, %11000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
      .db %00000000
; ==============================
; Table LOGO
; 0FFh - Empty line
; 0FEh - New line
; 0FEh,0FEh - End LOGO
; Width line = 454 dots
tab_7D3B:                       ;                                               <---------------------
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 45, 27, 26, 26, 42, 103, 40, 40, 105, 254
      .db 45, 27, 25, 28, 36, 110, 36, 40, 107, 254
      .db 44, 29, 24, 28, 33, 114, 34, 40, 108, 254
      .db 44, 29, 23, 30, 29, 119, 30, 40, 110, 254
      .db 43, 31, 22, 30, 27, 122, 28, 40, 111, 254
      .db 43, 31, 21, 32, 24, 125, 26, 39, 113, 254
      .db 42, 33, 20, 32, 22, 129, 22, 40, 114, 254
      .db 42, 33, 19, 34, 19, 132, 20, 39, 116, 254
      .db 41, 35, 18, 34, 18, 135, 16, 40, 117, 254
      .db 41, 35, 17, 36, 16, 137, 14, 39, 119, 254
      .db 40, 37, 16, 36, 15, 139, 12, 39, 120, 254
      .db 40, 37, 15, 38, 13, 142, 8, 39, 122, 254
      .db 39, 39, 14, 38, 12, 144, 6, 39, 123, 254
      .db 39, 39, 13, 40, 10, 147, 2, 39, 125, 254
      .db 38, 41, 12, 40, 10, 187, 126, 254
      .db 38, 41, 11, 42, 8, 37, 75, 74, 128, 254
      .db 37, 43, 10, 42, 8, 34, 79, 72, 129, 254
      .db 37, 43, 9, 44, 7, 32, 83, 68, 131, 254
      .db 36, 45, 8, 44, 7, 31, 85, 66, 132, 254
      .db 36, 45, 7, 46, 6, 32, 86, 62, 134, 254
      .db 35, 47, 6, 46, 6, 34, 85, 60, 135, 254
      .db 35, 47, 5, 48, 6, 36, 84, 56, 137, 254
      .db 34, 49, 4, 48, 6, 66, 55, 54, 138, 254
      .db 34, 49, 3, 50, 6, 71, 51, 50, 140, 254
      .db 33, 51, 2, 50, 7, 75, 47, 48, 24, 31, 86, 254
      .db 33, 51, 1, 52, 7, 77, 46, 44, 26, 34, 83, 254
      .db 32, 105, 8, 79, 44, 42, 27, 35, 82, 254
      .db 32, 106, 8, 80, 44, 38, 29, 12, 12, 11, 82, 254
      .db 31, 107, 9, 81, 43, 36, 30, 12, 13, 10, 82, 254
      .db 31, 108, 10, 81, 40, 38, 29, 12, 13, 10, 13, 16, 8, 10, 10, 9, 16, 254
      .db 30, 109, 12, 80, 37, 42, 27, 12, 13, 10, 10, 22, 6, 10, 8, 10, 16, 254
      .db 30, 110, 13, 80, 34, 44, 26, 12, 12, 11, 8, 26, 5, 9, 7, 10, 17, 254
      .db 29, 111, 15, 79, 31, 48, 24, 34, 8, 11, 6, 11, 4, 10, 6, 9, 18, 254
      .db 29, 29, 1, 51, 1, 30, 17, 77, 29, 50, 23, 32, 9, 10, 10, 10, 4, 10, 4, 10, 18, 254
      .db 28, 30, 2, 50, 2, 29, 20, 75, 26, 54, 21, 34, 6, 10, 11, 10, 5, 9, 3, 10, 19, 254
      .db 28, 29, 3, 49, 3, 30, 24, 71, 24, 56, 20, 36, 4, 10, 11, 10, 5, 10, 2, 9, 20, 254
      .db 27, 30, 4, 48, 4, 29, 30, 65, 22, 60, 18, 12, 13, 12, 3, 10, 11, 10, 6, 9, 1, 10, 20, 254
      .db 27, 29, 5, 47, 5, 30, 59, 36, 20, 62, 17, 12, 14, 11, 3, 10, 11, 10, 7, 18, 21, 254
      .db 26, 30, 6, 46, 6, 29, 62, 33, 18, 66, 15, 12, 14, 11, 3, 10, 11, 10, 7, 17, 22, 254
      .db 26, 29, 7, 45, 7, 30, 63, 31, 17, 68, 14, 12, 14, 11, 3, 10, 11, 10, 8, 16, 22, 254
      .db 25, 30, 8, 44, 8, 29, 63, 31, 15, 72, 12, 12, 14, 11, 4, 10, 10, 10, 9, 14, 23, 254
      .db 25, 29, 9, 43, 9, 30, 62, 31, 14, 74, 11, 12, 13, 12, 5, 11, 6, 11, 10, 13, 24, 254
      .db 24, 30, 10, 42, 10, 29, 60, 33, 12, 38, 2, 38, 9, 36, 7, 26, 12, 12, 24, 254
      .db 24, 29, 11, 41, 11, 30, 56, 36, 11, 37, 6, 37, 8, 34, 11, 22, 14, 11, 25, 254
      .db 23, 30, 12, 40, 12, 121, 9, 38, 8, 38, 6, 32, 16, 16, 16, 11, 26, 254
      .db 23, 29, 13, 39, 13, 120, 9, 37, 12, 37, 82, 13, 27, 254
      .db 22, 30, 14, 38, 14, 119, 7, 38, 14, 38, 80, 12, 28, 254
      .db 22, 29, 15, 37, 15, 118, 7, 38, 16, 38, 79, 10, 30, 254
      .db 21, 30, 16, 36, 16, 116, 6, 38, 20, 38, 117, 254
      .db 21, 29, 17, 35, 17, 115, 6, 38, 22, 38, 116, 254
      .db 20, 30, 18, 34, 18, 113, 5, 38, 26, 38, 114, 254
      .db 20, 29, 19, 33, 19, 111, 6, 38, 28, 38, 113, 254
      .db 19, 30, 20, 32, 20, 109, 5, 39, 30, 39, 111, 254
      .db 19, 29, 21, 31, 21, 107, 6, 38, 34, 38, 110, 254
      .db 18, 30, 22, 30, 22, 104, 6, 39, 36, 39, 108, 254
      .db 18, 29, 23, 29, 23, 102, 7, 38, 40, 38, 107, 254
      .db 17, 30, 24, 28, 24, 98, 8, 39, 42, 39, 105, 254
      .db 17, 29, 25, 27, 25, 95, 10, 38, 46, 38, 104, 254
      .db 16, 30, 26, 26, 26, 89, 13, 39, 48, 39, 102, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 255, 254
      .db 254
; ==============================
end_logo:                       ; fillers -> file lenght will be 1.635 bytes    <---------------------
      .db $FF, $FF, $FF
;\------------------------------
    .end

